import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class ChangingText extends Applet implements Runnable,MouseListener
{
	// Inizializzazioni variabili Font e Colore
	Font f = new Font( "sanserif" , Font.PLAIN , 38 );
	FontMetrics fm;
	Color tinta;
	float c = 0F;

	// Variabili interne per gestire la stringa e la sua posizione
	private String testo;
	private int x,y;

	// Passo di variazione del colore e di spostamento
	private float passo = 0.01F;
	private int passoSpostx = 2;
	private int passoSposty = 1;

	// Thread di esecuzione dell'aggiornamento
	private Thread aggiorna = null;

	// IMPORTANTE!
	// Inizializzazione delle variabili per il double buffering
	Image offScreenImage;
	Graphics offScreen;

	boolean sospeso = false;

	public void init() {
		setBackground( Color.black );

		// Raccolta parametri
		testo = getParameter( "testo" );
		if( testo == null ) testo = "Prova Applet";

		// Posizione Stringa
		fm = getFontMetrics(f);
		x = ( getSize().width - fm.stringWidth( testo ) )/2;
		y = ( getSize().height )/2;

		// Creazione immagine secondaria (buffer)
		offScreenImage = createImage( getSize().width , getSize().height );
		
		// Creazione di un contesto graphics per l'immagine buffer
		offScreen = offScreenImage.getGraphics();

		// Assegno l'applet stesso come event handler
		addMouseListener(this);
	}

	public void start() {
		if ( aggiorna == null ) {
			aggiorna = new Thread( this , "CambiaColori" );
			aggiorna.start();
		}
	}

	public void stop() {
		aggiorna = null;
	}

	public void destroy() {
	}

	
	// Ridefinisco il metodo update per evitare lo sfarfallio
	public void update(Graphics g) {
		paint(g);
	}

	// Disegno banalmente la scritta nel colore corrente
	public void paint(Graphics screen) {
		// Pulizia dell'immagine nascosta
		offScreen.clearRect( 0 , 0 , offScreenImage.getWidth(this) , offScreenImage.getHeight(this) );
		
		// Disegno sull'immagine nascosta
		offScreen.setFont( f );
		for( int i = 0 ; i<testo.length() ; i++ ) {
			tinta = Color.getHSBColor( c+passo*i , 1F , 1F );
			offScreen.setColor( tinta );
			offScreen.drawString( testo.substring(i,i+1) , x+fm.stringWidth(testo.substring(0,i)) , y );
		}
		// L'immagine nascosta viene portata in primo piano
		screen.drawImage( offScreenImage , 0 , 0 , this );
	}
	
	// Ciclo principale del thread
	public void run() {
		Thread me = Thread.currentThread();

//		// Iniziolizzo il colore
//		float c = 0F;
		
		// Finche' il thread e' attivo...
		while( me == aggiorna ) {
			// Se ho gia' passato tutti i colori, ricomincio da capo
			if( c >= 1F ) c = 0F;
			// Creo un nuovo oggetto color
			// Avanzo di un passo
			c += passo;
			
			// Spostamento della scritta sull'asse x
			if( (x+fm.stringWidth( testo ) >= getSize().width && passoSpostx > 0 )||
			    (x <= 0 && passoSpostx < 0 )) 
					passoSpostx = -passoSpostx;
					
			x += passoSpostx;

			// Spostamento della scritta sull'asse y
			if( ( y-fm.getAscent() <= 0  && passoSposty < 0 ) || 
				( y+fm.getDescent()  >= getSize().height && passoSposty > 0 ))
					passoSposty = -passoSposty;
			y += passoSposty;

			// Refresh
			repaint();

			// Pausa di 20 millisecondi
			try
			{
				Thread.sleep(50);
				synchronized(this) {
					while( sospeso ) wait();
				}
			}
			catch ( InterruptedException e )
			{
				System.err.println( "Thread interrotto!" );
			}

		}

	}

	public synchronized void mousePressed( MouseEvent e ) {
		e.consume();
		sospeso = !sospeso;
		if( !sospeso ) notify();
	}
	
	public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
		showStatus( "Changing Text by Giovanni Beltrame" );
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }
		
}
